Subject: Re: [patch 1/4] network dev read_mostly

From: Stephen Hemminger <[email-masked]>
Date: Fri, 16 Mar 2007 10:03:04 -0700

On Thu, 15 Mar 2007 09:17:22 -0400
Benjamin LaHaise <[email-masked]> wrote:

> On Thu, Mar 15, 2007 at 12:25:16AM -0700, David Miller wrote:
> > Could we obtain %rip relative addressing with the ELF
> > relocation approach I mentioned?
> 
> I think we can for some of the objects -- things like slab caches are 
> good candidates if we have the initialization done at init time, which 
> would actually be a very cool way of getting rid of the static slab 
> creation calls.  I'll cook something better up on the slab front.
> 
> As for other variables, many can't be rip relative as they often end up 
> pointing to addresses outside of the +/-2GB range we have there.
> 
> The main reason I came up with this was from looking at the various 
> kprobes and notifier chain overhead in common code paths.  In many 
> instances we need a single byte flag showing the feature is in use to 
> jump out of the hot path.
> 
> Then there are the selinux hooks....
> 
> 		-ben

There is an ugliness and maintenance vs performance tradeoff here.
The described implementation leaves me gagging. Is there some way
to do the same thing with ELF sections and post build processing?

-- 
Stephen Hemminger <[email-masked]>